Contents
Index 🔎︎

# GoSub...Return Statement

Lause kutsuu aliohjelmaa, joka on osoitettu rivitunnuksella (label) samassa proseduurissa tai funktiossa. Rivitunnuksen jälkeiset lauseet suoritetaan seuraavaan Return-lauseeseen asti. Tämän jälkeen ohjelma jatkuu lauseesta, joka seuraa GoSub-lausetta.

## Syntaksi:

    katso parametrit-kohdasta alempaa

## Parametrit:

Sub/Function

lauselohko1

Selite

lauselohko1

GoSub tunnus1

Exit Sub/Function

tunnus1:

lauselohko1

Return

End Sub/Function

GoSub-kutsuu paikallista aliohjelmaa, joka on merkitty rivitunnuksella saman aliohjelman tai funktion sisällä. Rivitunnuksen (label) nimen pitää päättyä kaksoispisteeseen (":").

Jos ohjelma tulee Return-lauseeseen, jota ei edellä GoSub-lause, LibreOffice Basic palauttaa virheilmoituksen. Käytä Exit Sub- tai Exit Function-lauseita varmistamaan, että ohjelma poistuu Sub- tai Function-rutiinista ennen seuraavaa Return-lausetta.

Seuraavassa esimerkissä havainnollistetaan GoSub- ja Return-lauseiden käyttöä. Aliohjelmaosio suoritetaan kahdesti, kun ohjelma laskee kahden käyttäjän syöttämän luvun neliöjuuren.

## Esimerkki:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox$ ("Anna ensimmäinen luku: ","NumberInput"))
        iInputb = Int(InputBox$ ("Anna ensimmäinen luku: ","NumberInput"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "Neliöjuuri luvusta";iInputa;" on";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "Neliöjuuri luvusta";iInputb;" on";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub